<template>
  <a-layout class="user-layout-container">
    <a-layout-header class="session-header">
      <div class="top">
        <div class="header">
          <img src="/logo_blue.svg?v2" class="logo" alt="logo">
        </div>
        <h1>SuperEHR | Quên mật khẩu</h1>
      </div>
    </a-layout-header>
    <a-layout-content>
      <div class="user-layout-login-wraper">
        <a-alert
          v-if="erroMessage"
          :message="erroMessage"
          type="error"
          show-icon
          style="margin-bottom: 24px;"
        />

        <a-alert
          v-if="showSuccess"
          style="margin-bottom: 24px;"
          message="Chúng tôi đã gửi thông tin cập nhật mật khẩu đến email của bạn. Vui lòng kiểm tra hộp thư đến và làm theo hướng dẫn."
          type="info"
          show-icon
          closable
        />

        <a-spin :spinning="confirmResetBtn">
          <a-form :form="form" class="user-layout-login">
            <a-form-item>
              <a-input
                v-decorator="[
                  'email',
                  {
                    rules: [
                      {
                        required: true,
                        whitespace: true,
                        type: 'email',
                        message: 'Vui lòng nhập chính xác email của bạn'
                      }
                    ],
                    validateTrigger: 'change'
                  }
                ]"
                type="text"
                placeholder="Địa chỉ email"
              >
                <a-icon slot="prefix" :style="{ color: 'rgba(0,0,0,.25)' }" type="mail" />
              </a-input>
            </a-form-item>
            <a-form-item>
              <a-button
                :loading="state.confirmResetBtn"
                :disabled="state.confirmResetBtn"
                @click.stop.prevent="handleSubmit"
                type="primary"
                html-type="submit"
                class="login-button"
              >
                Thiết lập lại mật khẩu
              </a-button>
            </a-form-item>
            <a-form-item>
              <span @click="backToLogin" style="float: left;">
                <a class="forge-password">Quay lại màn hình đăng nhập</a>
              </span>
            </a-form-item>
          </a-form>
        </a-spin>
      </div>
    </a-layout-content>
  </a-layout>
</template>

<script>
import { mapActions } from 'vuex'
import { ehrApi } from '@/api'
export default {
  data () {
    return {
      erroMessage: null,
      confirmResetBtn: false,
      form: this.$form.createForm(this),
      showSuccess: false,
      state: {
        confirmResetBtn: false
      }
    }
  },
  computed: {
    options () {
      const defaults = {
        username: '',
        isSignUpDisplayed: true
      }
      return Object.assign(defaults, this.signInConfig || {})
    }
  },
  methods: {
    ...mapActions('auth', ['login']),
    handleSubmit () {
      const {
        form: { validateFields },
        state
      } = this
      state.confirmResetBtn = true
      const validateFieldsKey = ['email']
      validateFields(validateFieldsKey, { force: true }, async (err, values) => {
        if (!err) {
          this.erroMessage = null
          try {
            const payload = { ...values }
            await ehrApi.user.resetPassword(payload)
            this.showSuccess = true
          } catch (error) {
            this.setError(error)
          } finally {
            state.confirmResetBtn = false
          }
        }
      })
    },
    backToLogin () {
      this.$bus.$emit('authState', 'signIn')
    },
    setError (err) {
      const errorMap = {
        'EMAIL_NOT_FOUND': 'Không tìm thấy địa chỉ email'
      }
      this.erroMessage = errorMap[err.errorCode] || 'Đã xảy ra lỗi, vui lòng thử lại'
    }
  }
}
</script>

<style lang="less" scoped>
.user-layout-login-wraper {
  width: 360px;
  margin: auto;
  & > h3 {
    font-size: 16px;
    margin-bottom: 20px;
  }
}
.user-layout-login {
  label {
    font-size: 14px;
  }

  .getCaptcha {
    display: block;
    width: 100%;
    height: 40px;
  }

  .forge-password {
    font-size: 14px;
  }

  button.login-button {
    width: 100%;
  }

  .user-login-other {
    text-align: left;
    margin-top: 24px;
    line-height: 22px;

    .item-icon {
      font-size: 24px;
      color: rgba(0, 0, 0, 0.2);
      margin-left: 16px;
      vertical-align: middle;
      cursor: pointer;
      transition: color 0.3s;

      &:hover {
        color: #1890ff;
      }
    }

    .register {
      float: right;
    }
  }
}
.user-layout-container {
  .top {
    text-align: center;

    .header {
      height: 80px;
      line-height: 44px;
      .logo {
        height: 80px;
        vertical-align: top;
        margin-right: 0px !important;
        border-style: none;
      }

      .title {
        font-size: 28px;
        color: rgba(0, 0, 0, 0.85);
        font-family: Avenir, 'Helvetica Neue', Arial, Helvetica, sans-serif;
        font-weight: 600;
        position: relative;
        top: 2px;
      }
    }
    .desc {
      font-size: 14px;
      color: rgba(0, 0, 0, 0.45);
      margin-top: 12px;
      line-height: 20px;
      margin-bottom: 40px;
    }
  }
}
</style>
